std::reverse_iterator< _Iterator > Class Template Reference
Iterators

`#include <stl_iterator.h>`

Inheritance diagram for std::reverse_iterator< _Iterator >:
[legend]

## Public Types

using | difference_type
using | iterator_category
using | iterator_concept
typedef _Iterator | iterator_type
typedef __traits_type::pointer | pointer
using | reference
using | value_type

## Public Member Functions

constexpr | reverse_iterator () noexcept(/*conditional */)
constexpr | reverse_iterator (const reverse_iterator &__x) noexcept(/*conditional */)
template<typename _Iter> requires __convertible<_Iter>
constexpr | reverse_iterator (const reverse_iterator< _Iter > &__x) noexcept(/*conditional */)
constexpr | reverse_iterator (iterator_type __x) noexcept(/*conditional */)
constexpr iterator_type | base () const noexcept(/*conditional */)
constexpr reference | operator* () const
constexpr reverse_iterator | operator+ (difference_type __n) const
constexpr reverse_iterator & | operator++ ()
constexpr reverse_iterator | operator++ (int)
constexpr reverse_iterator & | operator+= (difference_type __n)
constexpr reverse_iterator | operator- (difference_type __n) const
constexpr reverse_iterator & | operator-- ()
constexpr reverse_iterator | operator-- (int)
constexpr reverse_iterator & | operator-= (difference_type __n)
constexpr pointer | operator-> () const
reverse_iterator & | operator= (const reverse_iterator &)=default
template<typename _Iter> requires __convertible<_Iter> && assignable_from<_Iterator&, const _Iter&>
constexpr reverse_iterator & | operator= (const reverse_iterator< _Iter > &__x) noexcept(/*conditional */)
constexpr reference | operator[] (difference_type __n) const

## Protected Types

typedef iterator_traits< _Iterator > | __traits_type

## Protected Attributes

_Iterator | current

## Friends

constexpr iter_rvalue_reference_t< _Iterator > | iter_move (const reverse_iterator &__i) noexcept(is_nothrow_copy_constructible_v< _Iterator > &&noexcept(ranges::iter_move(--std::declval< _Iterator & >())))
template<indirectly_swappable< _Iterator > _Iter2>
constexpr void | iter_swap (const reverse_iterator &__x, const reverse_iterator< _Iter2 > &__y) noexcept(is_nothrow_copy_constructible_v< _Iterator > &&is_nothrow_copy_constructible_v< _Iter2 > &&noexcept(ranges::iter_swap(--std::declval< _Iterator & >(), --std::declval< _Iter2 & >())))

## Detailed Description

template<typename _Iterator>
class std::reverse_iterator< _Iterator >

Bidirectional and random access iterators have corresponding reverse iterator adaptors that iterate through the data structure in the opposite direction. They have the same signatures as the corresponding iterators. The fundamental relation between a reverse iterator and its corresponding iterator `i` is established by the identity:

&*(reverse_iterator(i)) == &*(i - 1)
std::reverse_iterator::reverse_iterator
constexpr reverse_iterator() noexcept(/*conditional */)
Definition bits/stl_iterator.h:179

This mapping is dictated by the fact that while there is always a pointer past the end of an array, there might not be a valid pointer before the beginning of an array. [24.4.1]/1,2

Reverse iterators can be tricky and surprising at first. Their semantics make sense, however, and the trickiness is a side effect of the requirement that the iterators must be safe.

Definition at line 131 of file bits/stl_iterator.h.

## Member Typedef Documentation

## __traits_type

template<typename _Iterator>

typedef iterator_traits<_Iterator> std::reverse_iterator< _Iterator >::__traits_type

protected

Definition at line 152 of file bits/stl_iterator.h.

## difference_type

template<typename _Iterator>

using std::reverse_iterator< _Iterator >::difference_type

Definition at line 167 of file bits/stl_iterator.h.

## iterator_category

template<typename _Iterator>

using std::reverse_iterator< _Iterator >::iterator_category

Definition at line 164 of file bits/stl_iterator.h.

## iterator_concept

template<typename _Iterator>

using std::reverse_iterator< _Iterator >::iterator_concept

Definition at line 161 of file bits/stl_iterator.h.

## iterator_type

template<typename _Iterator>

typedef _Iterator std::reverse_iterator< _Iterator >::iterator_type

Definition at line 155 of file bits/stl_iterator.h.

## pointer

template<typename _Iterator>

typedef __traits_type::pointer std::reverse_iterator< _Iterator >::pointer

Definition at line 156 of file bits/stl_iterator.h.

## reference

template<typename _Iterator>

using std::reverse_iterator< _Iterator >::reference

Definition at line 168 of file bits/stl_iterator.h.

## value_type

template<typename _Iterator>

using std::reverse_iterator< _Iterator >::value_type

Definition at line 166 of file bits/stl_iterator.h.

## Constructor & Destructor Documentation

## reverse_iterator() [1/4]

template<typename _Iterator>

std::reverse_iterator< _Iterator >::reverse_iterator | ( |  | ) |

inline constexpr noexcept

The default constructor value-initializes member `current`. If it is a pointer, that means it is zero-initialized.

Definition at line 179 of file bits/stl_iterator.h.

Referenced by std::reverse_iterator< iterator >::operator+(), and std::reverse_iterator< iterator >::operator-().

## reverse_iterator() [2/4]

template<typename _Iterator>

std::reverse_iterator< _Iterator >::reverse_iterator | ( | iterator_type | __x | ) |

inline explicit constexpr noexcept

This iterator will move in the opposite direction that `x` does.

Definition at line 188 of file bits/stl_iterator.h.

## reverse_iterator() [3/4]

template<typename _Iterator>

std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iterator > & | __x | ) |

inline constexpr noexcept

The copy constructor is normal.

Definition at line 197 of file bits/stl_iterator.h.

## reverse_iterator() [4/4]

template<typename _Iterator>
template<typename _Iter>
requires __convertible<_Iter>

std::reverse_iterator< _Iterator >::reverse_iterator | ( | const reverse_iterator< _Iter > & | __x | ) |

inline constexpr noexcept

A reverse_iterator across other types can be copied if the underlying iterator can be converted to the type of `current`.

Definition at line 215 of file bits/stl_iterator.h.

## Member Function Documentation

## base()

template<typename _Iterator>

iterator_type std::reverse_iterator< _Iterator >::base | ( |  | ) | const

inline nodiscard constexpr noexcept

Returns
  `current`, the iterator used for underlying work.

Definition at line 241 of file bits/stl_iterator.h.

Referenced by std::operator==().

## operator*()

template<typename _Iterator>

reference std::reverse_iterator< _Iterator >::operator* | ( |  | ) | const

inline nodiscard constexpr

Returns
  A reference to the value at `--current`

This requires that `--current` is dereferenceable.

Warning
  This implementation requires that for an iterator of the underlying iterator type, `x`, a reference obtained by `*x` remains valid after `x` has been modified or destroyed. This is a bug: http://gcc.gnu.org/PR51823

Definition at line 257 of file bits/stl_iterator.h.

## operator+()

template<typename _Iterator>

reverse_iterator std::reverse_iterator< _Iterator >::operator+ | ( | difference_type | __n | ) | const

inline nodiscard constexpr

Returns
  A reverse_iterator that refers to `current` - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 340 of file bits/stl_iterator.h.

## operator++() [1/2]

template<typename _Iterator>

reverse_iterator & std::reverse_iterator< _Iterator >::operator++ | ( |  | ) |

inline constexpr

Returns
  `*this`

Decrements the underlying iterator.

Definition at line 289 of file bits/stl_iterator.h.

## operator++() [2/2]

template<typename _Iterator>

reverse_iterator std::reverse_iterator< _Iterator >::operator++ | ( | int |  | ) |

inline constexpr

Returns
  The original value of `*this`

Decrements the underlying iterator.

Definition at line 301 of file bits/stl_iterator.h.

## operator+=()

template<typename _Iterator>

reverse_iterator & std::reverse_iterator< _Iterator >::operator+= | ( | difference_type | __n | ) |

inline constexpr

Returns
  *this

Moves the underlying iterator backwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 350 of file bits/stl_iterator.h.

## operator-()

template<typename _Iterator>

reverse_iterator std::reverse_iterator< _Iterator >::operator- | ( | difference_type | __n | ) | const

inline nodiscard constexpr

Returns
  A reverse_iterator that refers to `current` - __n

The underlying iterator must be a Random Access Iterator.

Definition at line 363 of file bits/stl_iterator.h.

## operator--() [1/2]

template<typename _Iterator>

reverse_iterator & std::reverse_iterator< _Iterator >::operator-- | ( |  | ) |

inline constexpr

Returns
  `*this`

Increments the underlying iterator.

Definition at line 314 of file bits/stl_iterator.h.

## operator--() [2/2]

template<typename _Iterator>

reverse_iterator std::reverse_iterator< _Iterator >::operator-- | ( | int |  | ) |

inline constexpr

Returns
  A reverse_iterator with the previous value of `*this`

Increments the underlying iterator.

Definition at line 326 of file bits/stl_iterator.h.

## operator-=()

template<typename _Iterator>

reverse_iterator & std::reverse_iterator< _Iterator >::operator-= | ( | difference_type | __n | ) |

inline constexpr

Returns
  *this

Moves the underlying iterator forwards __n steps. The underlying iterator must be a Random Access Iterator.

Definition at line 373 of file bits/stl_iterator.h.

## operator->()

template<typename _Iterator>

pointer std::reverse_iterator< _Iterator >::operator-> | ( |  | ) | const

inline nodiscard constexpr

Returns
  A pointer to the value at `--current`

This requires that `--current` is dereferenceable.

Definition at line 270 of file bits/stl_iterator.h.

## operator=()

template<typename _Iterator>
template<typename _Iter>
requires __convertible<_Iter> && assignable_from<_Iterator&, const _Iter&>

reverse_iterator & std::reverse_iterator< _Iterator >::operator= | ( | const reverse_iterator< _Iter > & | __x | ) |

inline constexpr noexcept

Definition at line 228 of file bits/stl_iterator.h.

## operator[]()

template<typename _Iterator>

reference std::reverse_iterator< _Iterator >::operator[] | ( | difference_type | __n | ) | const

inline nodiscard constexpr

Returns
  The value at `current` - __n - 1

The underlying iterator must be a Random Access Iterator.

Definition at line 386 of file bits/stl_iterator.h.

## Friends And Related Symbol Documentation

## reverse_iterator

template<typename _Iterator>
template<typename _Iter>

friend class reverse_iterator

friend

Definition at line 139 of file bits/stl_iterator.h.

## iter_move

template<typename _Iterator>

iter_rvalue_reference_t< _Iterator > iter_move | ( | const reverse_iterator< _Iterator > & | __i | ) |

friend

Definition at line 392 of file bits/stl_iterator.h.

## iter_swap

template<typename _Iterator>
template<indirectly_swappable< _Iterator > _Iter2>

void iter_swap | ( | const reverse_iterator< _Iterator > & | __x,
|  | const reverse_iterator< _Iter2 > & | __y )

friend

Definition at line 402 of file bits/stl_iterator.h.

## Member Data Documentation

## current

template<typename _Iterator>

_Iterator std::reverse_iterator< _Iterator >::current

protected

Definition at line 150 of file bits/stl_iterator.h.

The documentation for this class was generated from the following file:

- bits/stl_iterator.h